diff a/test/hotspot/jtreg/premain/javac/javac-test.sh b/test/hotspot/jtreg/premain/javac/javac-test.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac/javac-test.sh
@@ -0,0 +1,476 @@
+# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+#======================================================================
+# Regression test to run javac with premain prototype, to test the CDS and AOT changes.
+#
+# QUICK START:
+#  bash javac-test.sh -n $JAVA
+#
+#    This shows you all the 5 steps for using the premain prototype:
+#
+#       (STEP 1 of 5) Dump javac.classlist (skipped)
+#       (STEP 2 of 5) Create Static javac-static.jsa (skipped)
+#       (STEP 3 of 4) Run with javac-static.jsa and dump profile in javac-dynamic.jsa (With Training Data Replay) (skipped)
+#       (STEP 4 of 4) Run with javac-dynamic.jsa and generate AOT code (skipped)
+#       (STEP 5 of 5) Final production run: with javac-dynamic.jsa and load AOT code (skipped)
+#
+#  bash javac-test.sh $JAVA
+#    This runs all the above 5 steps
+#======================================================================
+
+# Usage:   bash javac-test.sh $OPTS $JAVA
+#          bash javac-test.sh $OPTS $JAVA $JVMARGS
+#
+# $JAVA must be from inside your JDK build dir. E.g., /your/build/dir/images/jdk/bin/java
+#
+# $OPTS is optional. Examples:
+#
+# - Don't run any tests, just print the command-lines
+#     bash cds-test.sh -n $JAVA
+#
+# - Just run test #4
+#     bash cds-test.sh -r 4 $JAVA
+#
+# - Run test 5, enable the JIT compile log, and loop for 10000 iterations. Also pass -Xmx16g to the JVM.
+#     bash cds-test.sh -r 5 -lcomp -l 10000 $JAVA -Xmx16g
+#
+# See the "while" loop below for all available options
+
+MYDIR=$(cd $(dirname $0); pwd)
+echo script is installed at $MYDIR
+
+LIMIT=
+QUIET=
+LOOPS=100
+EXTRA_ARGS=
+EXIT_WHEN_FAIL=0
+
+while true; do
+    if [[ $1 = "-lcomp" ]]; then
+        # Log compiler
+        EXTRA_ARGS="$EXTRA_ARGS -XX:+PrintCompilation"
+        shift
+    elif [[ $1 = "-lsc" ]]; then
+        # Log shared code
+        EXTRA_ARGS="$EXTRA_ARGS -Xlog:scc -Xlog:scc,nmethod"
+        shift
+    elif [[ $1 = "-r" ]]; then
+        # Limit the run to a single test case
+        LIMIT=$2
+        shift
+        shift
+    elif [[ $1 = "-l" ]]; then
+        # Number of loops for JavacBench
+        LOOPS=$2
+        shift
+        shift
+    elif [[ $1 = "-n" ]]; then
+        # Don't run any test cases, just print their help message and command line
+        LIMIT=0
+        shift
+    elif [[ $1 = "-f" ]]; then
+        # Exit the script with exit code 1 as soon as a test fails
+        EXIT_WHEN_FAIL=1
+        shift
+    elif [[ $1 = "-q" ]]; then
+        # Don't print the help messages and command line of test cases that are skipped
+        QUIET=1
+        shift
+    elif [[ $1 = "-all" ]]; then
+        # Run all test cases (that are not included in the 5 steps)"
+        # If this flag is NOT specified, only the tests with STEP in their description will be executed.
+        DOALL=1
+        shift
+    else
+        break
+    fi
+done
+
+JVM=$1
+
+echo JVM=$JVM
+
+JSA_SUFFIX=-$JVM
+
+# Ioi-specific
+if test "$TESTBED" != ""; then
+    IOI_PREFIX=$(cd $TESTBED/../..; pwd)
+fi
+
+if test "$JVM" = "p"; then
+    # Ioi-specific
+    PRODUCT_BLD=${IOI_PREFIX}
+    IOI_TEST_VM=${IOI_PREFIX}-product/images/jdk
+elif test "$JVM" = "d"; then
+    PRODUCT_BLD=${IOI_PREFIX}
+    IOI_TEST_VM=${IOI_PREFIX}-debug/images/jdk
+elif test "$JVM" = "fd"; then
+    PRODUCT_BLD=${IOI_PREFIX}
+    IOI_TEST_VM=${IOI_PREFIX}-fastdebug/images/jdk
+elif [[ ${JVM}XX =~ /images/jdk/bin/javaXX ]]; then
+    PRODUCT_BLD=$(cd $(dirname $JVM)/../../..; pwd);
+    JSA_SUFFIX=
+else
+    echo "Please specify the location of the JVM (must be in your /build/dir/images/jdk/bin)"
+    exit 1
+fi
+
+JVM_AND_ARGS=$@
+TEST_NUM=0
+
+function test-info () {
+    if test "$DOALL" != "1"; then
+        if [[ "$@" =~ STEP ]] ; then
+            true
+        else
+            return 1
+        fi
+    fi
+
+    TEST_NUM=$(expr $TEST_NUM + 1)
+    declare -gA infos
+    declare -gA cmds
+    cmds[$TEST_NUM]=$CMD
+    infos[$TEST_NUM]=$*
+    local SKIPPED=""
+    if test "$LIMIT" != "" && test "$LIMIT" != "$TEST_NUM"; then
+        SKIPPED=" (skipped)"
+    fi
+    if test "$QUIET" = ""; then
+        echo ======================================================================
+        echo "Test $TEST_NUM $*$SKIPPED"
+        echo $CMD
+    fi
+    if test "$SKIPPED" != ""; then
+        return 1
+    else
+        return 0
+    fi
+}
+
+function record_success () {
+    somepassed=1
+    declare -gA status
+    status[$TEST_NUM]=OK
+    echo "RESULT: $TEST_NUM = OK"
+}
+
+function record_failure () {
+    somefailed=1
+    declare -gA status
+    status[$TEST_NUM]=FAILED
+    echo "RESULT: $TEST_NUM = FAILED"
+    if test "$EXIT_WHEN_FAIL" = "1"; then
+        touch fail-stop.txt
+        exit 1
+    fi
+}
+
+cd $MYDIR
+
+if test ! -f JavacBench.jar; then
+    cat > JavacBench.java <<EOF
+//this file is auto-generated. Do not add to source control and do not edit.
+//import org.openjdk.jmh.annotations.*;
+
+import javax.tools.*;
+import java.io.*;
+import java.net.URI;
+import java.util.*;
+
+//@State(Scope.Benchmark)
+public class JavacBench {
+    static class ClassFile extends SimpleJavaFileObject {
+        private final ByteArrayOutputStream baos = new ByteArrayOutputStream();
+        protected ClassFile(String name) {
+            super(URI.create("memo:///" + name.replace('.', '/') + Kind.CLASS.extension), Kind.CLASS);
+        }
+        @Override
+        public ByteArrayOutputStream openOutputStream() { return this.baos; }
+        byte[] toByteArray() { return baos.toByteArray(); }
+    }
+    static class FileManager extends ForwardingJavaFileManager<JavaFileManager> {
+        private Map<String, ClassFile> classesMap = new HashMap<String, ClassFile>();
+        protected FileManager(JavaFileManager fileManager) {
+            super(fileManager);
+        }
+        @Override
+        public ClassFile getJavaFileForOutput(Location location, String name, JavaFileObject.Kind kind, FileObject source) {
+            ClassFile classFile = new ClassFile(name);
+            classesMap.put(name, classFile);
+            return classFile;
+        }
+        public Map<String, byte[]> getByteCode() {
+            Map<String, byte[]> result = new HashMap<>();
+            for (Map.Entry<String, ClassFile> entry : classesMap.entrySet()) {
+                result.put(entry.getKey(), entry.getValue().toByteArray());
+            }
+            return result;
+        }
+    }
+    static class SourceFile extends SimpleJavaFileObject {
+        private CharSequence sourceCode;
+        public SourceFile(String name, CharSequence sourceCode) {
+            super(URI.create("memo:///" + name.replace('.', '/') + Kind.SOURCE.extension), Kind.SOURCE);
+            this.sourceCode = sourceCode;
+        }
+        @Override
+        public CharSequence getCharContent(boolean ignore) {
+            return this.sourceCode;
+        }
+    }
+
+    public Object compile(int count) {
+        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
+        DiagnosticCollector<JavaFileObject> ds = new DiagnosticCollector<>();
+        Collection<SourceFile> sourceFiles = sources10k.subList(0, count);
+
+        try (FileManager fileManager = new FileManager(compiler.getStandardFileManager(ds, null, null))) {
+            JavaCompiler.CompilationTask task = compiler.getTask(null, fileManager, null, null, null, sourceFiles);
+            if (task.call()) {
+                return fileManager.getByteCode();
+            } else {
+                for (Diagnostic<? extends JavaFileObject> d : ds.getDiagnostics()) {
+                  System.out.format("Line: %d, %s in %s", d.getLineNumber(), d.getMessage(null), d.getSource().getName());
+                  }
+                throw new InternalError("compilation failure");
+            }
+        } catch (IOException e) {
+            throw new InternalError(e);
+        }
+    }
+
+    List<SourceFile> sources10k;
+
+    List<SourceFile> generate(int count) {
+        ArrayList<SourceFile> sources = new ArrayList<>(count);
+        for (int i = 0; i < count; i++) {
+            sources.add(new SourceFile("HelloWorld" + i,
+                    "public class HelloWorld" + i + " {" +
+                            "    public static void main(String[] args) {" +
+                            "        System.out.println(\"Hellow World!\");" +
+                            "    }" +
+                            "}"));
+        }
+        return sources;
+    }
+    //@Setup
+    public void setup() {
+        sources10k = generate(10_000);
+    }
+
+  public static void main(String args[]) throws Throwable {
+    JavacBench bench = new JavacBench();
+    bench.setup();
+
+    if (args.length >= 0) {
+        int count = Integer.parseInt(args[0]);
+        if (count > 0) {
+            bench.compile(count);
+        }
+    }
+  }
+}
+EOF
+    (set -x
+    rm -rf tmpclasses
+    mkdir -p tmpclasses
+    ${PRODUCT_BLD}/images/jdk/bin/javac -d tmpclasses JavacBench.java || exit 1
+    ${PRODUCT_BLD}/images/jdk/bin/jar cf JavacBench.jar -C tmpclasses . || exit 1
+    rm -rf tmpclasses
+    ) || exit 1
+fi
+
+#----------------------------------------------------------------------
+CMD="$JVM_AND_ARGS \
+    -cp JavacBench.jar -XX:DumpLoadedClassList=javac.classlist \
+    -Xlog:class+load=debug:file=javac.class+load.log \
+    JavacBench 1000"
+test-info "(STEP 1 of 5) Dump javac.classlist" &&
+if $CMD; then
+    ls -l javac.classlist
+    wc -l javac.classlist
+    record_success
+    # remove old log
+    rm -f javac.class+load.log.*
+else
+    record_failure
+fi
+
+JSA=javac-static${JSA_SUFFIX}.jsa
+
+#----------------------------------------------------------------------
+CMD="$JVM_AND_ARGS \
+    -Xshare:dump -XX:SharedArchiveFile=$JSA \
+    -XX:SharedClassListFile=javac.classlist \
+    -XX:+AOTClassLinking \
+    -cp JavacBench.jar \
+    -Xlog:cds=debug,cds+class=debug,cds+resolve=debug:file=javac.staticdump.log::filesize=0"
+test-info "(STEP 2 of 5) Create Static $JSA" &&
+if $CMD; then
+    ls -l $JSA
+    record_success
+    rm -f javac.staticdump.log.*
+else
+    record_failure
+fi
+
+#----------------------------------------------------------------------
+CMD="$JVM_AND_ARGS $EXTRA_ARGS \
+    -XX:SharedArchiveFile=$JSA \
+    -cp JavacBench.jar JavacBench $LOOPS"
+test-info "Run with $JSA" &&
+if $CMD; then
+    record_success
+else
+    record_failure
+fi
+
+#----------------------------------------------------------------------
+CMD="$JVM_AND_ARGS $EXTRA_ARGS \
+    -cp JavacBench.jar JavacBench $LOOPS"
+test-info "Run with default archive" &&
+if $CMD; then
+    record_success
+else
+    record_failure
+fi
+
+#----------------------------------------------------------------------
+CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xshare:off -Xlog:cds=debug \
+    -cp JavacBench.jar JavacBench $LOOPS"
+test-info "Run without CDS" &&
+if $CMD; then
+    record_success
+else
+    record_failure
+fi
+
+TESTS="1 2"
+
+for i in $TESTS; do
+    if test $i = 2; then
+        REPLAY=" (With Training Data Replay)"
+        X1="-XX:+RecordTraining"
+        X2="-XX:+ReplayTraining"
+        STEP3="(STEP 3 of 5) "
+        STEP4="(STEP 4 of 5) "
+        STEP5="(STEP 5 of 5) "
+   fi
+
+    DYNJSA=javac-dynamic1${JSA_SUFFIX}-$i.jsa
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xlog:cds=debug \
+            -cp JavacBench.jar -XX:ArchiveClassesAtExit=$DYNJSA $X1 JavacBench $LOOPS"
+    test-info "Dump CDS dynamic archive$REPLAY" &&
+    if $CMD; then
+            record_success
+        else
+            record_failure
+        fi
+
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xlog:cds \
+        -cp JavacBench.jar -XX:SharedArchiveFile=$DYNJSA $X2 JavacBench $LOOPS"
+    test-info "Use CDS dynamic archive$REPLAY" &&
+    if $CMD; then
+        record_success
+    else
+        record_failure
+    fi
+
+    JSA2=javac-dynamic2${JSA_SUFFIX}-$i.jsa
+    if test "$JSA2" = "javac-dynamic2-2.jsa"; then
+        JSA2=javac-dynamic.jsa
+    fi
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xlog:cds=debug,cds+class=debug:file=javac.dynamicdump.log::filesize=0 \
+        -XX:SharedArchiveFile=$JSA -XX:ArchiveClassesAtExit=$JSA2 $X1 \
+        -cp JavacBench.jar JavacBench $LOOPS"
+    test-info "${STEP3}Run with $JSA and dump profile in $JSA2${REPLAY}" &&
+    if $CMD; then
+        record_success
+    else
+        record_failure
+    fi
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS \
+        -XX:SharedArchiveFile=$JSA2 $X2 \
+        -cp JavacBench.jar JavacBench $LOOPS"
+    test-info "Run with $JSA2 $REPLAY" &&
+    if $CMD; then
+        record_success
+    else
+        record_failure
+    fi
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xlog:scc*=warning:file=javac.scc-store.log::filesize=0 \
+        -XX:SharedArchiveFile=$JSA2 $X2 -XX:+StoreCachedCode -XX:CachedCodeFile=${JSA2}-sc -XX:CachedCodeMaxSize=100M \
+        -cp JavacBench.jar JavacBench $LOOPS"
+    test-info "${STEP4}Run with $JSA2 and generate AOT code" &&
+    if $CMD; then
+        record_success
+    else
+        record_failure
+    fi
+
+    #----------------------------------------------------------------------
+    CMD="$JVM_AND_ARGS $EXTRA_ARGS -Xlog:scc*=warning:file=javac.scc-load.log::filesize=0 \
+        -XX:SharedArchiveFile=$JSA2 $X2 -XX:+LoadCachedCode -XX:CachedCodeFile=${JSA2}-sc \
+        -cp JavacBench.jar JavacBench $LOOPS"
+    test-info "${STEP5}Final production run: with $JSA2 and load AOT code" &&
+    if $CMD; then
+        record_success
+    else
+        record_failure
+    fi
+done
+
+echo ===SUMMARY===
+for (( i=1; i<=$TEST_NUM; i++ )) ; do
+    if test "${status[$i]}" != ""; then
+        echo ......................
+        echo $i ${infos[$i]} = ${status[$i]}
+        echo "    $(echo ${cmds[$i]})"
+    fi
+done
+
+if test "$somefailed" = "1"; then
+    echo ""
+    echo '***********************SOME TESTS FAILED ********************************************'
+    echo ""
+    for (( i=1; i<=$TEST_NUM; i++ )) ; do
+        if test "${status[$i]}" = "FAILED"; then
+            echo $i ${infos[$i]} = ${status[$i]}
+        fi
+    done
+    echo ""
+elif test "$somepassed" = "1"; then
+    echo ""
+    echo '*** all passed *****'
+    echo ""
+fi
diff a/test/hotspot/jtreg/premain/javac_helloworld/HelloWorld.java b/test/hotspot/jtreg/premain/javac_helloworld/HelloWorld.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_helloworld/HelloWorld.java
@@ -0,0 +1,30 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+public class HelloWorld {
+    public static void main(String args[]) {
+        System.out.println("Hello World");
+    }
+}
diff a/test/hotspot/jtreg/premain/javac_helloworld/Makefile b/test/hotspot/jtreg/premain/javac_helloworld/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_helloworld/Makefile
@@ -0,0 +1,4 @@
+clean:
+	rm -rf *.jsa *.jsa-sc *.log* *.classlist *~ Simple.jar tmpclasses HelloWorld.class logs report.csv
+
+
diff a/test/hotspot/jtreg/premain/javac_helloworld/run.sh b/test/hotspot/jtreg/premain/javac_helloworld/run.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_helloworld/run.sh
@@ -0,0 +1,62 @@
+# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+# This script measure the performance of "javac HelloWorld.java"
+#
+# Specify one or more jvms:
+#
+#     bash run.sh $jvm1
+#     bash run.sh $jvm1 $jvm2 ...
+#
+# It's possible to specify extra parameters for the jvms. E.g.
+#
+#     bash run.sh a/bin/java 'b/bin/java -Xint'  'c/bin/java -Xmixed'
+#
+# See ../lib/bench-lib.sh for sample timing data and more information.
+
+APP=Javac
+CMDLINE="com.sun.tools.javac.Main HelloWorld.java"
+
+source ../lib/bench-lib.sh
+
+# Example of comparing two leyden builds
+#
+# $ bash run.sh /bld/leyden/new/bin/java /bld/leyden/old/bin/java
+# ===report.csv================================================
+# Run,1_xon,1_td,1_aot,2_xon,2_td,2_aot
+# 1,118.68000,95.003000,91.050000,118.69000,99.08000,94.664000
+# 2,117.96000,95.262000,91.223000,120.73000,96.863000,96.67000
+# 3,118.43000,96.11000,90.455000,121.16000,98.138000,94.71000
+# 4,115.742000,98.342000,91.075000,120.956000,99.306000,93.407000
+# 5,118.60000,98.172000,90.635000,121.783000,100.952000,95.33000
+# 6,119.958000,99.836000,90.052000,122.60000,101.492000,94.346000
+# 7,118.391000,99.28000,91.158000,121.96000,101.476000,93.113000
+# 8,121.36000,100.026000,90.705000,124.63000,101.697000,94.93000
+# 9,119.84000,100.23000,91.469000,122.93000,102.776000,96.37000
+# 10,121.15000,101.35000,92.78000,124.60000,103.405000,95.88000
+# ==============================jvm1 /bld/leyden/new/bin/java
+# [1_xon ] Premain Prototype (CDS )                      119.00 ms
+# [1_td  ] Premain Prototype (CDS + Training Data)        98.34 ms
+# [1_aot ] Premain Prototype (CDS + Training Data + AOT)  91.06 ms
+# ==============================jvm2 /bld/leyden/old/bin/java
+# [2_xon ] Premain Prototype (CDS )                      121.99 ms
+# [2_td  ] Premain Prototype (CDS + Training Data)       100.50 ms
+# [2_aot ] Premain Prototype (CDS + Training Data + AOT)  94.94 ms
diff a/test/hotspot/jtreg/premain/javac_new_workflow/HelloWorld.java b/test/hotspot/jtreg/premain/javac_new_workflow/HelloWorld.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_new_workflow/HelloWorld.java
@@ -0,0 +1,30 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+public class HelloWorld {
+    public static void main(String args[]) {
+        System.out.println("Hello World");
+    }
+}
diff a/test/hotspot/jtreg/premain/javac_new_workflow/Makefile b/test/hotspot/jtreg/premain/javac_new_workflow/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_new_workflow/Makefile
@@ -0,0 +1,25 @@
+# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+clean:
+	rm -f *.classlist *.jsa *.log *.cds *.cds.preimage *.cds.code cmds.txt report.csv *~ HelloWorld.class
+
+
diff a/test/hotspot/jtreg/premain/javac_new_workflow/run.sh b/test/hotspot/jtreg/premain/javac_new_workflow/run.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_new_workflow/run.sh
@@ -0,0 +1,99 @@
+# Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+# This is a new propsed workflow for the "terminal stage" of the Leyden
+# condenser pipeline (see https://openjdk.org/projects/leyden/notes/03-toward-condensers)
+#
+# The CDS and AOT artifacts are generated in a single step.
+#
+# Please run this script and look at the commands in the generated cmds.txt file.
+
+# Usage:
+#
+# bash run.sh $JAVA
+# bash run.sh $JAVA args ....
+#
+# e.g.
+#
+# bash.sh /jdk3/bld/le4/images/jdk/bin/java
+# bash.sh /jdk3/bld/le4/images/jdk/bin/java -XX:+UnlockDiagnosticVMOptions -XX:-AOTInvokeDynamicLinking
+
+# These options are enabled by default for training run. You can either disable them in the command-line
+# as shown above, or edit the following line
+#
+# The training run uses two JVM processes. We add "pid" to the log to distinguish their output.
+TRAINING_OPTS="${TRAINING_OPTS} -Xlog:scc -Xlog:cds=debug::uptime,tags,pid"
+TRAINING_OPTS="${TRAINING_OPTS} -XX:+AOTClassLinking"
+#TRAINING_OPTS="${TRAINING_OPTS} -XX:+RecordTraining"
+
+# These options are enabled by default for training run. 
+#PRODUCTION_OPTS="${PRODUCTION_OPTS} -XX:+ReplayTraining"
+
+
+launcher=$1
+shift
+
+rm -f cmds.txt
+#========================================
+# One-step training run
+#   Remove javac.cds, so that it will be regenerated
+rm -f javac.cds*
+cmd="$launcher -XX:CacheDataStore=javac.cds $TRAINING_OPTS "$@" com.sun.tools.javac.Main HelloWorld.java"
+
+echo "# commands for training run" >> cmds.txt
+echo "rm -f javac.cds*" >> cmds.txt
+echo $cmd >> cmds.txt
+echo >> cmds.txt
+eval $cmd
+
+#========================================
+# Production run
+#    TODO: add flags for AOT cache
+cmd="$launcher $PRODUCTION_OPTS -Xlog:cds -Xlog:scc -XX:CacheDataStore=javac.cds $@ com.sun.tools.javac.Main HelloWorld.java"
+perfcmd="perf stat -r 20 $(echo $cmd | sed -e 's/ [-]Xlog:[^ ]*//g')"
+echo "Production run: "
+echo "   $cmd"
+echo "   "
+
+rm -f HelloWorld.class
+eval "$cmd"
+
+echo "# command for production run" >> cmds.txt
+echo $cmd >> cmds.txt
+echo >> cmds.txt
+
+echo "# commands for benchmarking" >> cmds.txt
+echo perf stat -r 20 $launcher $@ com.sun.tools.javac.Main HelloWorld.java >> cmds.txt
+echo $perfcmd >> cmds.txt
+echo >> cmds.txt
+
+echo "cat cmds.txt"
+cat cmds.txt
+
+echo ========================================
+echo "Verifying"
+if (set -x; $launcher -Xshare:off -cp . HelloWorld); then
+    echo javac seems to be working correctly with $PRODUCTION_OPTS -XX:CacheDataStore=javac.cds
+else
+    echo "Failed?????????????????"
+    exit 1
+fi
+
diff a/test/hotspot/jtreg/premain/javac_new_workflow/run_bench.sh b/test/hotspot/jtreg/premain/javac_new_workflow/run_bench.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/javac_new_workflow/run_bench.sh
@@ -0,0 +1,62 @@
+# Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+# This script measure the performance of "javac HelloWorld.java"
+#
+# Specify one or more jvms:
+#
+#     bash run.sh $jvm1
+#     bash run.sh $jvm1 $jvm2 ...
+#
+# It's possible to specify extra parameters for the jvms. E.g.
+#
+#     bash run.sh a/bin/java 'b/bin/java -Xint'  'c/bin/java -Xmixed'
+#
+# See ../lib/bench-lib.sh for sample timing data and more information.
+
+APP=Javac
+CMDLINE="com.sun.tools.javac.Main HelloWorld.java"
+
+source ../lib/bench-lib-new-workflow.sh
+
+# Example of comparing two leyden builds
+#
+# $ bash run_bench.sh /bld/leyden/new/bin/java /bld/leyden/old/bin/java
+# ===report.csv================================================
+# Run,1_xoff,1_xon,1_aot,2_xoff,2_xon,2_aot
+# 1,251.04000,144.48000,93.34000,254.87000,150.73000,86.31000
+# 2,241.86000,156.01000,94.01000,262.28000,147.82000,93.03000
+# 3,248.77000,138.17000,84.51000,242.18000,132.86000,87.26000
+# 4,249.83000,162.71000,94.93000,247.70000,152.60000,85.95000
+# 5,249.90000,157.8000,88.98000,239.13000,152.79000,89.16000
+# 6,250.33000,161.91000,84.07000,236.03000,156.12000,85.63000
+# 7,244.62000,122.86000,75.37000,248.32000,142.14000,91.10000
+# 8,255.41000,118.35000,83.61000,233.07000,130.12000,90.43000
+# 9,244.33000,153.18000,81.47000,250.07000,150.15000,91.92000
+# 10,247.32000,129.58000,79.58000,244.58000,154.66000,82.08000
+# ==============================jvm1 /bld/leyden/new/bin/java
+# [1_xoff] Premain JDK (CDS disabled)                   248.31 ms
+# [1_xon ] Premain JDK (CDS enabled)                    143.63 ms
+# [1_aot ] Premain Prototype (CDS + Training Data + AOT)  85.76 ms
+# ==============================jvm2 /bld/leyden/old/bin/java
+# [2_xoff] Premain JDK (CDS disabled)                   245.68 ms
+# [2_xon ] Premain JDK (CDS enabled)                    146.74 ms
+# [2_aot ] Premain Prototype (CDS + Training Data + AOT)  88.23 ms
diff a/test/hotspot/jtreg/premain/jmh/Makefile b/test/hotspot/jtreg/premain/jmh/Makefile
--- /dev/null
+++ b/test/hotspot/jtreg/premain/jmh/Makefile
@@ -0,0 +1,3 @@
+clean:
+	rm -rf *.jsa *.jsa-sc *.log* *.classlist *~ xml
+
